using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_CRM._0_Modelos;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_CRM._1_Datos
{
    public class CRMH_Gastos_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _dbcontext, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
           
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _dbcontext, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
           
        }

        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities dbcontext = null;

            dynamic dnm_Gastos_Modelo = null;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.LazyLoadingEnabled = false;

                //Consulta.....................................................................
                var consulta = (from obj_CRMH_Gastos in dbcontext.CRMH_Gastos
                                     .Include(nameof(CRMH_Gastos.MAE_TiposGastos))
                                     .Include(nameof(CRMH_Gastos.MAE_TiposPagos))
                                     .Include(nameof(CRMH_Gastos.CRM_Terminales))
                                     .Include(nameof(CRMH_Gastos.MAE_Empleados))
                               where obj_CRMH_Gastos.id.Equals(_lng_id)
                                select obj_CRMH_Gastos);
                //............................................................................

                if (consulta != null && consulta.Count() > 0)
                {
                    //Convertir a Dynamic
                    dnm_Gastos_Modelo = consulta.FirstOrDefault();
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRMH_Gastos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }
            return dnm_Gastos_Modelo;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public INTERNO_CRMH_Gastos_Listado_Modelo Obtener_Modelo_Listado(long _lng_id)
        {
            Exferia_Entities dbcontext = null;

            INTERNO_CRMH_Gastos_Listado_Modelo mdl_INTERNO_CRMH_Gastos_Listado_Modelo = null;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.LazyLoadingEnabled = false;

                //Consulta.....................................................................
                var consulta = (from obj_CRMH_Gastos in dbcontext.CRMH_Gastos
                                     .Include(nameof(CRMH_Gastos.MAE_TiposGastos))
                                     .Include(nameof(CRMH_Gastos.MAE_TiposPagos))
                                     .Include(nameof(CRMH_Gastos.CRM_Terminales))
                                     .Include(nameof(CRMH_Gastos.MAE_Empleados))
                                where obj_CRMH_Gastos.id.Equals(_lng_id)
                                select new INTERNO_CRMH_Gastos_Listado_Modelo
                                {
                                    id = obj_CRMH_Gastos.id,
                                    importe = obj_CRMH_Gastos.importe,
                                    fechaHora = obj_CRMH_Gastos.fechaHora,
                                    kilometrosActuales = obj_CRMH_Gastos.kilometrosActuales,
                                    observaciones = obj_CRMH_Gastos.observaciones,
                                    guid = obj_CRMH_Gastos.guid,
                                    //ids
                                    idEmpleado = obj_CRMH_Gastos.idEmpleado,
                                    idTerminal = obj_CRMH_Gastos.idTerminal,
                                    idTipoGasto = obj_CRMH_Gastos.idTipoGasto,
                                    idTipoPago = obj_CRMH_Gastos.idTipoPago,
                                    id_Gasto_CRMS = obj_CRMH_Gastos.id_Gasto_CRMS,
                                    //Terminal
                                    Terminal_Codigo = obj_CRMH_Gastos.CRM_Terminales.codigo,
                                    Terminal_Descripcion = obj_CRMH_Gastos.CRM_Terminales.descripcion,
                                    Terminal_FechaBorrado = obj_CRMH_Gastos.CRM_Terminales.fechaBorrado,
                                    //Empleado
                                    Empleado_Codigo = obj_CRMH_Gastos.MAE_Empleados.codigo,
                                    Empleado_Descripcion = obj_CRMH_Gastos.MAE_Empleados.nombre,
                                    Empleado_FechaBorrado = obj_CRMH_Gastos.MAE_Empleados.fechaBorrado,
                                    //TipoGasto
                                    TipoGasto_Codigo = obj_CRMH_Gastos.MAE_TiposGastos.codigo,
                                    TipoGasto_Descripcion = obj_CRMH_Gastos.MAE_TiposGastos.descripcion,
                                    TipoGasto_FechaBorrado = obj_CRMH_Gastos.MAE_TiposGastos.fechaBorrado,
                                    //TipoPago
                                    TipoPago_Codigo = obj_CRMH_Gastos.MAE_TiposPagos.codigo,
                                    TipoPago_Descripcion = obj_CRMH_Gastos.MAE_TiposPagos.descripcion,
                                    TipoPago_FechaBorrado = obj_CRMH_Gastos.MAE_TiposPagos.fechaBorrado,

                                });
                //............................................................................

                if (consulta != null && consulta.Count() > 0)
                {
                    //Convertir a Dynamic
                    mdl_INTERNO_CRMH_Gastos_Listado_Modelo = consulta.FirstOrDefault();
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRMH_Gastos_Datos) + "/" + nameof(Obtener_Modelo_Listado), true);
            }
            finally
            {
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }
            return mdl_INTERNO_CRMH_Gastos_Listado_Modelo;
        }

        public List<INTERNO_CRMH_Gastos_Listado_Modelo> Obtener_Listado_PorGUID(string _str_GUID)
        {
            Exferia_Entities dbcontext = null;

            List<INTERNO_CRMH_Gastos_Listado_Modelo> lst_CRMH_Encuestas = null;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.LazyLoadingEnabled = false;

                //Consulta ..............................................................................
                var consulta = from obj_CRMH_Gastos in dbcontext.CRMH_Gastos
                               where obj_CRMH_Gastos.guid.Equals(_str_GUID)
                               select new INTERNO_CRMH_Gastos_Listado_Modelo
                               {
                                   id = obj_CRMH_Gastos.id,
                                   importe = obj_CRMH_Gastos.importe,
                                   fechaHora = obj_CRMH_Gastos.fechaHora,
                                   kilometrosActuales = obj_CRMH_Gastos.kilometrosActuales,
                                   observaciones = obj_CRMH_Gastos.observaciones,
                                   guid = obj_CRMH_Gastos.guid,
                                   //ids
                                   idEmpleado = obj_CRMH_Gastos.idEmpleado,
                                   idTerminal = obj_CRMH_Gastos.idTerminal,
                                   idTipoGasto = obj_CRMH_Gastos.idTipoGasto,
                                   idTipoPago = obj_CRMH_Gastos.idTipoPago,
                                   id_Gasto_CRMS = obj_CRMH_Gastos.id_Gasto_CRMS,
                                   //Terminal
                                   Terminal_Codigo = obj_CRMH_Gastos.CRM_Terminales.codigo,
                                   Terminal_Descripcion =  obj_CRMH_Gastos.CRM_Terminales.descripcion,
                                   Terminal_FechaBorrado = obj_CRMH_Gastos.CRM_Terminales.fechaBorrado,
                                   //Empleado
                                   Empleado_Codigo =  obj_CRMH_Gastos.MAE_Empleados.codigo ,
                                   Empleado_Descripcion = obj_CRMH_Gastos.MAE_Empleados.nombre ,
                                   Empleado_FechaBorrado = obj_CRMH_Gastos.MAE_Empleados.fechaBorrado,
                                   //TipoGasto
                                   TipoGasto_Codigo =  obj_CRMH_Gastos.MAE_TiposGastos.codigo,
                                   TipoGasto_Descripcion =  obj_CRMH_Gastos.MAE_TiposGastos.descripcion,
                                   TipoGasto_FechaBorrado = obj_CRMH_Gastos.MAE_TiposGastos.fechaBorrado,
                                   //TipoPago
                                   TipoPago_Codigo = obj_CRMH_Gastos.MAE_TiposPagos.codigo,
                                   TipoPago_Descripcion = obj_CRMH_Gastos.MAE_TiposPagos.descripcion,
                                   TipoPago_FechaBorrado = obj_CRMH_Gastos.MAE_TiposPagos.fechaBorrado,
                               };

                //......................................................................................

                if (consulta != null && consulta.Count() > 0)
                {
                    lst_CRMH_Encuestas = consulta.ToList();
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRMH_Encuestas_Datos) + "/" + nameof(Obtener_Listado_PorGUID), true);
            }

            return lst_CRMH_Encuestas;
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities dbcontext = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.LazyLoadingEnabled = false;

                CRMH_Gastos mdl_CRMH_Gastos_AGrabar = (CRMH_Gastos)_mdl_obj;

                CRMH_Gastos mdl_CRMH_Gastos_Final = new CRMH_Gastos();
                CRMH_Gastos mdl_CRMH_Gastos_DatosViejos = new CRMH_Gastos();

                //Grabar Datos
                var valorDevuelto = dbcontext.CRMH_Gastos.Where(m => m.id.Equals(mdl_CRMH_Gastos_AGrabar.id));
                if (valorDevuelto != null && valorDevuelto.Count() > 0)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    mdl_CRMH_Gastos_Final = valorDevuelto.FirstOrDefault();

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CRMH_Gastos_Final, mdl_CRMH_Gastos_DatosViejos, false, false);

                    //Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CRMH_Gastos_AGrabar, mdl_CRMH_Gastos_Final, false, false);
                }
                else
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CRMH_Gastos_AGrabar, mdl_CRMH_Gastos_Final, false, false);

                    dbcontext.CRMH_Gastos.Add(mdl_CRMH_Gastos_Final);
                }
                dbcontext.SaveChanges();

                //Grabar un registro de trazabilidad con los datos de la transaccion ralizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CRMH_Gastos), mdl_CRMH_Gastos_DatosViejos, mdl_CRMH_Gastos_Final, mdl_ValorDevuelto_Modelo.TipoAccion, dbcontext);

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = mdl_CRMH_Gastos_Final.id;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRMH_Gastos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            CRMH_Gastos mdl_CRMH_Gastos_Final = null;

            //Se utiliza la transaccion por la llamada al procedimiento almacenado
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    //Primer Intento de Borrado
                    using (Exferia_Entities dbcontext = new Exferia_Entities())
                    {
                        dbcontext.Configuration.LazyLoadingEnabled = false;

                        var valorDevuelto = dbcontext.CRMH_Gastos.Where(m => m.id.Equals(_lng_id));
                        if (valorDevuelto != null && valorDevuelto.Count() > 0)
                        {
                            mdl_CRMH_Gastos_Final = valorDevuelto.FirstOrDefault();
                            //Se intenta borrar, si diera un error porque esta relacionado se graba la fecha de baja

                            //Si no existe relaciones borramos la ubicacion
                            dbcontext.CRMH_Gastos.Remove(mdl_CRMH_Gastos_Final);
                            dbcontext.SaveChanges();

                            //Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(CRMH_Gastos), null, mdl_CRMH_Gastos_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, dbcontext);

                            //Devolver tambien el objeto
                            mdl_ValorDevuelto_Modelo.Id = mdl_CRMH_Gastos_Final.id;

                            // Se termina la Transaccion Correctamente
                            transaccion_SQL.Complete();
                        }
                    }
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(CRMH_Gastos_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    // Finalizar transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities dbcontext = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idGastos = (List<long>)_mdl_obj;

                if (lst_idGastos != null & lst_idGastos.Count > 0)
                {
                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_ids = "";
                    foreach (long lng_id in lst_idGastos)
                    {
                        str_ids += (lng_id + ",");
                    }

                    string str_SQL = " DELETE FROM " + nameof(CRMH_Gastos) +
                                     " WHERE " + nameof(CRMH_Gastos.id) + " in (" + str_ids.Substring(0, str_ids.Length - 1) + ")";

                    dbcontext.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRMH_Gastos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                // Finalizar transaccion
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion   
    }
}
